const dbSAPPS = require('../../helpers/db');
require('dotenv').config();
const { Op } = require('sequelize');

module.exports = {
    create,
    getAll,
    option,
    count,
    update,
    delete: _delete
};

/**
 * Format an array of dosageForms by appending a modifier field to each company.
 * The modifier field is the full name of the user who last modified the company.
 * @param {Object[]} dosageForms - The array of dosageForms to format.
 * @returns {Promise<Object[]>} - The formatted array of dosageForms.
 */
const formatWithModifier = async (dosageForms) => {
    return Promise.all(
        dosageForms.map(async (dosageForm) => {
            const modifier = await dbSAPPS.User.findOne({
                where: {
                    id: dosageForm.modified_by
                },
                attributes: ['full_name']
            });

            return {
                ...dosageForm,
                modifier: modifier?.full_name
            };
        })
    );
};

/**
 * Retrieves all dosageForms with their parent dosageForm title.
 * @param {Object} params - The query parameters.
 * @param {number[]} params.dosageFormsId - The ids of the dosageForms to retrieve.
 * @returns {Promise<Object>} - The response object with the dosageForms and success status.
 */
async function getAll(params) {
    try {
        // filters
        const filterConditions = {};

        let dosageForms = []
        dosageForms = await dbSAPPS.DosageForm.findAll({
            where: filterConditions,
            order: [['modified', 'DESC']],
        });

        dosageForms = dosageForms.map(dosageForm => {
            return {
                ...dosageForm.dataValues
            }
        });

        dosageForms = await formatWithModifier(dosageForms);

        return {
            dosageForms,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Get dosageForm items with their respective settings.
 * @param {Object} params - An object that contains parameters to filter the dosageForm items.
 * @param {boolean|string} params.is_parent - A boolean or string indicating whether the dosageForm items should be parents or not.
 * @returns {Promise<Object>} Resolves with an object that contains the dosageForm items and a success flag.
 * @example
 * const result = await option({ is_parent: true });
 * console.log(result);
 */
async function option(params) {
    try {
        // filter
        const filterConditions = {};

        let options = [];
        options = await dbSAPPS.DosageForm.findAll({
            attributes: ['id', 'name', 'display_name'],
            where: filterConditions,
            order: [['name', 'ASC']]
        });

        return {
            options,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Count active dosageForm items
 * 
 * @returns {Promise<{
 *   count: number,
 *   success: boolean,
 *   message: string
 * }>} 
 */

async function count(params) {
    try {
        // filter
        const filterConditions = {};

        const count = await dbSAPPS.DosageForm.count({
            where: filterConditions
        });

        return {
            count,
            success: true,
            message: 'Loaded successfully!'
        };
    } catch (error) {
        const errorMessage = error?.message || 'Failed to load, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Creates a new dosageForm item.
 * 
 * @param {Object} params - The new dosageForm item data.
 * @param {string} params.name - The name of the dosageForm item.
 * @param {string} params.title - The title of the dosageForm item.
 * @param {number} [params.parent_id] - The ID of the parent dosageForm item.
 * @param {string} [params.url] - The URL of the dosageForm item.
 * @param {string} [params.icon] - The icon of the dosageForm item.
 * @param {string} [params.type=link] - The type of the dosageForm item (link, group, collapse, separator).
 * @param {boolean} [params.enabled=true] - Whether the dosageForm item is enabled.
 * @param {number} [params.creation=Date.now()] - The creation timestamp of the dosageForm item.
 * @param {number} [params.modified=Date.now()] - The last modification timestamp of the dosageForm item.
 * @param {number} [params.owner=1] - The ID of the user who created the dosageForm item.
 * @param {number} [params.modified_by=1] - The ID of the user who last modified the dosageForm item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the dosageForm item creation process.
 */
async function create(params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const existingDisplayName = await dbSAPPS.DosageForm.findOne({
            where: { display_name: params.display_name },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dbSAPPS.DosageForm.create(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Updates an existing dosageForm item.
 * 
 * @param {number} id - The ID of the dosageForm item to update.
 * @param {Object} params - The updated dosageForm item data.
 * @param {string} [params.name] - The new name of the dosageForm item.
 * @param {string} [params.title] - The new title of the dosageForm item.
 * @param {number} [params.parent_id] - The new parent ID of the dosageForm item.
 * @param {string} [params.url] - The new URL of the dosageForm item.
 * @param {string} [params.icon] - The new icon of the dosageForm item.
 * @param {string} [params.type] - The new type of the dosageForm item (link, group, collapse, separator).
 * @param {boolean} [params.enabled] - Whether the dosageForm item is enabled or not.
 * @param {number} [params.creation] - The new creation timestamp of the dosageForm item.
 * @param {number} [params.modified] - The new last modification timestamp of the dosageForm item.
 * @param {number} [params.owner] - The new ID of the user who created the dosageForm item.
 * @param {number} [params.modified_by] - The new ID of the user who last modified the dosageForm item.
 * 
 * @returns {Promise<{success: boolean, message: string}>} Result of the dosageForm item update process.
 */
async function update(id, params) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const dosageForm = await dbSAPPS.DosageForm.findByPk(id);
        if (!dosageForm) return { success: false, message: 'ID not found!' };

        // validate existing
        const existingDisplayName = await dbSAPPS.DosageForm.findOne({
            where: {
                display_name: params.display_name,
                id: {
                    [Op.ne]: id
                }
            },
            transaction
        });
        if (existingDisplayName) {
            return {
                success: false,
                message: `"${params.display_name}" is already taken.`
            };
        }

        // save
        await dosageForm.update(params, { transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Saved successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to save, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}

/**
 * Delete a dosageForm
 * @param {number} id - the id of the dosageForm
 * @returns {Promise<object>} - the result of the delete
 */
async function _delete(id) {
    const transaction = await dbSAPPS.sequelize.transaction();
    try {
        // validate existing
        const dosageForm = await dbSAPPS.DosageForm.findByPk(id);
        if (!dosageForm) return { success: false, message: 'ID not found!' };

        // delete
        await dosageForm.destroy({ transaction });

        await transaction.commit();
        return {
            success: true,
            message: 'Deleted successfully!'
        };
    } catch (error) {
        await transaction.rollback();
        const errorMessage = error?.message || 'Failed to delete, please try again!';
        return {
            success: false,
            message: errorMessage
        };
    }
}
